Make use of $suitedir.
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20 tmpdir="$scratchdir"
21 fromdir="$tmpdir/from"
22 todir="$tmpdir/to"
23 chkdir="$tmpdir/chk"
24
25 # For itemized output:
26 all_plus='+++++++++'
27 allspace='         '
28 dots='.....' # trailing dots after changes
29
30 # Berkley's nice.
31 PATH="$PATH:/usr/ucb"
32
33 if diff -u "$suitedir/rsync.fns" "$suitedir/rsync.fns" >/dev/null 2>&1; then
34     diffopt="-u"
35 else
36     diffopt="-c"
37 fi
38
39 HOME="$scratchdir"
40 export HOME
41
42 runtest() {
43     echo $ECHO_N "Test $1: $ECHO_C"
44     if eval "$2"
45     then
46         echo "$ECHO_T   done."
47         return 0
48     else
49         echo "$ECHO_T failed!"
50         return 1
51     fi
52 }
53
54 set_cp_destdir() {
55     while test $# -gt 1; do
56         shift
57     done
58     destdir="$1"
59 }
60
61 # Perform a "cp -p", making sure that timestamps are really the same,
62 # even if the copy rounded microsecond times on the destination file.
63 cp_touch() {
64     cp -p "${@}" || test_fail "cp -p failed"
65     if test $# -gt 2 -o -d "$2"; then
66         set_cp_destdir "${@}" # sets destdir var
67         while test $# -gt 1; do
68             destname="$destdir/`basename $1`"
69             touch -r "$destname" "$1" "$destname"
70             shift
71         done
72     else
73         touch -r "$2" "$1" "$2"
74     fi
75 }
76
77 # Call this if you want to filter out verbose messages (-v or -vv) from
78 # the output of an rsync run (whittling the output down to just the file
79 # messages).  This isn't needed if you use -i without -v.
80 filter_outfile() {
81     sed -e '/^building file list /d' \
82         -e '/^sending incremental file list/d' \
83         -e '/^created directory /d' \
84         -e '/^done$/d' \
85         -e '/ --whole-file$/d' \
86         -e '/^total: /d' \
87         -e '/^client charset: /d' \
88         -e '/^server charset: /d' \
89         -e '/^$/,$d' \
90         <"$outfile" >"$outfile.new"
91     mv "$outfile.new" "$outfile"
92 }
93
94 printmsg() {
95     echo "$1"
96 }
97
98 rsync_ls_lR() {
99     find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
100 }
101
102 check_perms() {
103     perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
104     if test $perms = $2; then
105         return 0
106     fi
107     echo "permissions: $perms on $1"
108     echo "should be:   $2"
109     test_fail "failed test $3"
110 }
111
112 rsync_getgroups() { 
113     "$TOOLDIR/getgroups"
114 }
115
116
117 ####################
118 # Build test directories $todir and $fromdir, with $fromdir full of files.
119
120 hands_setup() {
121     # Clean before creation
122     rm -rf "$fromdir"
123     rm -rf "$todir"
124
125     [ -d "$tmpdir" ] || mkdir "$tmpdir"
126     [ -d "$fromdir" ] || mkdir "$fromdir"
127     [ -d "$todir" ] || mkdir "$todir"
128
129     # On some BSD systems, the umask affects the mode of created
130     # symlinks, even though the mode apparently has no effect on how
131     # the links behave in the future, and it cannot be changed using
132     # chmod!  rsync always sets its umask to 000 so that it can
133     # accurately recreate permissions, but this script is probably run
134     # with a different umask. 
135
136     # This causes a little problem that "ls -l" of the two will not be
137     # the same.  So, we need to set our umask before doing any creations.
138
139     # set up test data
140     touch "$fromdir/empty"
141     mkdir "$fromdir/emptydir"
142
143     # a hundred lines of text or so
144     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
145
146     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
147     umask 0
148     ln -s nolf "$fromdir/nolf-symlink"
149     umask 022
150
151     cat "$srcdir"/*.c > "$fromdir/text"
152     mkdir "$fromdir/dir"
153     cp "$fromdir/text" "$fromdir/dir"
154     mkdir "$fromdir/dir/subdir"
155     echo some data > "$fromdir/dir/subdir/foobar.baz"
156     mkdir "$fromdir/dir/subdir/subsubdir"
157     if [ -r /etc ]; then
158         ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
159     else
160         ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
161     fi
162     mkdir "$fromdir/dir/subdir/subsubdir2"
163     if [ -r /bin ]; then
164         ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
165     else
166         ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
167     fi
168
169 #      echo testing head:
170 #      ls -lR "$srcdir" | head -10 || echo failed
171 }
172
173
174 ####################
175 # Many machines do not have "mkdir -p", so we have to build up long paths.
176 # How boring.  
177 makepath() {
178     for p in "${@}"; do
179         (echo "        makepath $p"
180
181         # Absolut Unix.
182         if echo $p | grep '^/' >/dev/null
183         then
184             cd /
185         fi
186     
187         # This will break if $p contains a space.
188         for c in `echo $p | tr '/' ' '`
189         do 
190             if [ -d "$c" ] || mkdir "$c" 
191             then
192                 cd "$c" || return $?
193             else
194                 echo "failed to create $c" >&2; return $?
195             fi
196         done)
197     done
198 }
199
200
201
202 ###########################
203 # Run a test (in '$1') then compare directories $2 and $3 to see if
204 # there are any difference.  If there are, explain them.
205
206 # So normally basically $1 should be an rsync command, and $2 and $3
207 # the source and destination directories.  This is only good when you
208 # expect to transfer the whole directory exactly as is.  If some files
209 # should be excluded, you might need to use something else.
210
211 checkit() {
212     failed=
213
214     # We can just write everything to stdout/stderr, because the
215     # wrapper hides it unless there is a problem.
216
217     echo "Running: \"$1\""  
218     eval "$1" 
219     status=$?
220     if [ $status != 0 ]; then
221         failed="YES";
222     fi
223
224     echo "-------------"
225     echo "check how the directory listings compare with diff:"
226     echo ""
227     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
228     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
229     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
230
231     echo "-------------"
232     echo "check how the files compare with diff:"
233     echo ""
234     if [ "x$4" != x ]; then
235         echo "  === Skipping (as directed) ==="
236     else
237         diff -r $diffopt "$2" "$3" || failed=YES
238     fi
239
240     echo "-------------"
241     if [ -z "$failed" ] ; then
242         return 0
243     else
244         return 1
245     fi
246 }
247
248
249 build_rsyncd_conf() {
250     # Build an appropriate configuration file
251     conf="$scratchdir/test-rsyncd.conf"
252     echo "building configuration $conf"
253
254     port=2612
255     pidfile="$scratchdir/rsyncd.pid"
256     logfile="$scratchdir/rsyncd.log"
257     hostname=`uname -n`
258
259     cat >"$conf" <<EOF
260 # rsyncd configuration file autogenerated by $0
261
262 pid file = $pidfile
263 use chroot = no
264 munge symlinks = no
265 hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
266 log file = $logfile
267 log format = %i %h [%a] %m (%u) %l %f%L
268 transfer logging = yes
269 exclude = ? foobar.baz
270 max verbosity = 4
271 #uid = 0
272 #gid = 0
273
274 [test-from]
275         path = $fromdir
276         read only = yes
277         comment = r/o
278
279 [test-to]
280         path = $todir
281         read only = no
282         comment = r/w
283
284 [test-scratch]
285         path = $scratchdir
286         read only = no
287
288 [test-hidden]
289         path = $fromdir
290         list = no
291 EOF
292
293     # Build a helper script to ignore exit code 23
294     ignore23="$scratchdir/ignore23"
295     echo "building help script $ignore23"
296
297     cat >"$ignore23" <<'EOT'
298 if "${@}"; then
299     exit
300 fi
301
302 ret=$?
303
304 if test $ret = 23; then
305     exit
306 fi
307
308 exit $ret
309 EOT
310 chmod +x "$ignore23"
311 }
312
313
314 build_symlinks() {
315     mkdir "$fromdir"
316     date >"$fromdir/referent"
317     ln -s referent "$fromdir/relative"
318     ln -s "$fromdir/referent" "$fromdir/absolute"
319     ln -s nonexistent "$fromdir/dangling"
320     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
321 }
322
323 test_fail() {
324     echo "$@" >&2
325     exit 1
326 }
327
328 test_skipped() {
329     echo "$@" >&2
330     echo "$@" > "$tmpdir/whyskipped"
331     exit 77
332 }
333
334 # It failed, but we expected that.  don't dump out error logs, 
335 # because most users won't want to see them.  But do leave
336 # the working directory around.
337 test_xfail() {
338     echo "$@" >&2
339     exit 78
340 }
341
342 # Determine what shell command will appropriately test for links.
343 ln -s foo "$scratchdir/testlink"
344 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
345 do
346     for switch in -h -L
347     do
348         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
349         then
350             # how nice
351             TEST_SYMLINK_CMD="$cmd $switch"
352             # i wonder if break 2 is portable?
353             break 2
354         fi
355    done
356 done
357 # ok, now get rid of it
358 rm "$scratchdir/testlink"
359
360
361 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
362 then
363     test_fail "Couldn't determine how to test for symlinks"
364 else
365     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
366 fi
367         
368
369 # Test whether something is a link, allowing for shell peculiarities
370 is_a_link() {
371     # note the variable contains the first option and therefore is not quoted
372     $TEST_SYMLINK_CMD "$1"
373 }
374
375
376 # We need to set the umask to be reproducible.  Note also that when we
377 # do some daemon tests as root, we will setuid() and therefore the
378 # directory has to be writable by the nobody user in some cases.  The
379 # best thing is probably to explicitly chmod those directories after
380 # creation.
381  
382 umask 022